﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2016 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONFIG_FREEBSD_H_
#define INCLUDE_NN_NLIB_CONFIG_FREEBSD_H_
#ifndef INCLUDE_NN_NLIB_CONFIG_H_
# error do not include directly
#endif

#if defined(__FreeBSD__)
#include <sys/param.h>
# if __FreeBSD_version < 1000000
#  error nlib requires FreeBSD 10.0 or higher.
# endif
#endif

#if defined(__clang__)
# include "nn/nlib/Config_clang.h"
# elif defined(__GNUC__)
# include "nn/nlib/Config_gcc.h"
#else
# error
#endif

#define NLIB_HAS_VIRTUALMEMORY

#include <sys/types.h>
#include <sys/sysctl.h>
#include <cxxabi.h>

#define NLIB_PATHMAPPER_FORSAMPLE \
    extern "C" char *getcwd(char *buf, size_t size);                \
    nlib_ns::NativePathMapper g_PathMapper;                         \
    inline void InitPathMapperForSample() {                         \
        int mib[4];                                                 \
        mib[0] = CTL_KERN;                                          \
        mib[1] = KERN_PROC;                                         \
        mib[2] = KERN_PROC_PATHNAME;                                \
        mib[3] = -1;                                                \
        char dir[1024];                                             \
        size_t cb = sizeof(dir);                                    \
        int err = sysctl(mib, 4, dir, &cb, NULL, 0);                \
        if (err != 0 || cb == 0 || nlib_strlen(dir) == 0) {         \
            char* cwd = getcwd(dir, 1024);                          \
            if (cwd) {                                              \
                g_PathMapper.AddMap(cwd, "nlibpath:///readwrite/"); \
                g_PathMapper.AddMap(cwd, "nlibpath:///readonly/");  \
            }                                                       \
        } else {                                                    \
            *const_cast<char*>(nlib_strrchr(dir, '/')) = '\0';      \
            g_PathMapper.AddMap(dir, "nlibpath:///readonly/");      \
            g_PathMapper.AddMap(dir, "nlibpath:///readwrite/");     \
        }                                                           \
    }

#define NLIB_MAINFUNC int main(int argc, char** argv) { \
    bool result = SampleMain(argc, argv); nlib_printf(result ? "OK\n" : "NG\n"); \
    return result ? 0 : 1; }

#define NLIB_RETHROW_UNWIND catch (struct _Unwind_Exception&)

#endif  // INCLUDE_NN_NLIB_CONFIG_FREEBSD_H_
