﻿
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2016 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONFIG_GCC_H_
#define INCLUDE_NN_NLIB_CONFIG_GCC_H_
#ifndef INCLUDE_NN_NLIB_CONFIG_H_
# error do not include directly
#endif

#if defined(__GNUC__)

#ifdef __EXCEPTIONS
# define NLIB_EXCEPTION_ENABLED
#endif

#if __GNUC__ > 4
#  define NLIB_CXX11_RVALUE_REFERENCES
#  define NLIB_CXX11_STATIC_ASSERTIONS
#  define NLIB_CXX11_EXTERN_TEMPLATES
#  define NLIB_CXX11_DEFAULTED_AND_DELETED_FUNCTIONS
#  define NLIB_CXX11_EXPLICIT_CONVERSION_OPERATORS
#  define NLIB_CXX11_NULL_POINTER_CONSTANT
#  define NLIB_CXX11_RANGE_BASED_FOR
#  define NLIB_CXX11_EXPLICIT_VIRTUAL_OVERRIDES
#  define NLIB_CXX11_TEMPLATE_ALIAS
#  define NLIB_CXX11_ALIGNMENT_SUPPORT
#  define NLIB_CXX11_LAMBDAS
#  define NLIB_CXX11_CONSTEXPR
#  define NLIB_CXX11_DEFAULT_TEMPLATE_ARGUMENT_FOR_FUNCTION_TEMPLATES
#elif __GNUC__ == 4
# if __GNUC_MINOR__ <= 6 || __cplusplus > 199711L

#  if __GNUC_MINOR__ >= 3
#   define NLIB_CXX11_RVALUE_REFERENCES
#   define NLIB_CXX11_STATIC_ASSERTIONS
#   define NLIB_CXX11_EXTERN_TEMPLATES
#   define NLIB_CXX11_SWAPHEADER
#   define NLIB_CXX11_DEFAULT_TEMPLATE_ARGUMENT_FOR_FUNCTION_TEMPLATES
#  endif

#  if __GNUC_MINOR__ >= 4
#   define NLIB_CXX11_DEFAULTED_AND_DELETED_FUNCTIONS
#  endif

#  if __GNUC_MINOR__ >= 5
#  endif

#  if __GNUC_MINOR__ >= 6
#   define NLIB_CXX11_EXPLICIT_CONVERSION_OPERATORS
#   define NLIB_CXX11_NULL_POINTER_CONSTANT
#   define NLIB_CXX11_RANGE_BASED_FOR
#  endif

#  if __GNUC_MINOR__ >= 7
#   define NLIB_CXX11_VARIADIC_TEMPLATES  // gcc4.6 cannot expand 'typedef Types<TAIL...> Tail;'
#   define NLIB_CXX11_CONSTEXPR
#   define NLIB_CXX11_EXPLICIT_VIRTUAL_OVERRIDES
#   define NLIB_CXX11_TEMPLATE_ALIAS
#   define NLIB_CXX11_LAMBDAS
#   define NLIB_CXX11_DELEGATING_CONSTRUCTORS
#  endif

#  if __GNUC_MINOR__ >= 8
#   define NLIB_CXX11_ALIGNMENT_SUPPORT
#  endif
# endif
#else
# error
#endif

#include <bits/c++config.h>
#ifndef __GLIBCXX__
# error c++config.h should define __GLIBCXX__ ...
#endif

#if __GLIBCXX__ >= 20100414
# define NLIB_CXX11_UNIQUEPTR
# define NLIB_CXX11_STDLIB_ARRAY
# define NLIB_CXX11_STDLIB_UNORDERED
# define NLIB_CXX11_STDLIB_TUPLE
#endif
#if __GLIBCXX__ >= 20120322
// https://gcc.gnu.org/onlinedocs/libstdc++/manual/abi.html
# define NLIB_HAS_NATIVE_TYPETRAITS
# define NLIB_CXX11_STDLIB_RANDOM
# define NLIB_CXX11_STDLIB_CHRONO
# define NLIB_CXX11_STDLIB_ATOMIC
#endif

#include <cassert> // NOLINT
#define NLIB_ASSERT assert

#define NLIB_ALIGNAS(x) __attribute__((aligned(x)))
#define NLIB_ALIGNOF(tp) __alignof__(tp)

#endif
#endif  // INCLUDE_NN_NLIB_CONFIG_GCC_H_
