
/*---------------------------------------------------------------------------*

  Project: CrossRoad
  Copyright (C)2012-2016 Nintendo.  All rights reserved.

  These coded instructions, statements, and computer programs contain
  proprietary information of Nintendo of America Inc. and/or Nintendo
  Company Ltd., and are protected by Federal copyright law.  They may
  not be disclosed to third parties or copied or duplicated in any form,
  in whole or in part, without the prior written consent of Nintendo.

 *---------------------------------------------------------------------------*/

#pragma once
#ifndef INCLUDE_NN_NLIB_CONFIG_OSX_H_
#define INCLUDE_NN_NLIB_CONFIG_OSX_H_
#ifndef INCLUDE_NN_NLIB_CONFIG_H_
# error do not include directly
#endif

#include <mach-o/dyld.h>
#include <TargetConditionals.h>

#if defined(__clang__)
# include "nn/nlib/Config_clang.h"
#else
# error
#endif

#define NLIB_HAS_VIRTUALMEMORY

#define NLIB_PATHMAPPER_FORSAMPLE \
    nlib_ns::NativePathMapper g_PathMapper; \
    inline void InitPathMapperForSample() { \
        g_PathMapper.AddMap(CMAKE_CURRENT_BINARY_DIR, "nlibpath:///readonly/"); \
        g_PathMapper.AddMap(CMAKE_CURRENT_BINARY_DIR, "nlibpath:///readwrite/"); \
    }

/*
#define NLIB_PATHMAPPER_FORSAMPLE \
    nlib_ns::NativePathMapper g_PathMapper; \
    inline void InitPathMapperForSample() { \
        char dir[1024]; \
        uint32_t size = sizeof(dir); \
        _NSGetExecutablePath(dir, &size); \
        *const_cast<char*>(nlib_strrchr(dir, '/')) = '\0'; \
        g_PathMapper.AddMap(dir, "nlibpath:///readonly/"); \
        g_PathMapper.AddMap(dir, "nlibpath:///readwrite/"); \
    }
*/

#ifndef NLIB_OSX_MAINFUNC_NAME
# define NLIB_OSX_MAINFUNC_NAME main
#endif

#define NLIB_MAINFUNC extern "C" int NLIB_OSX_MAINFUNC_NAME(int argc, char** argv) { \
    bool result = SampleMain(argc, argv); nlib_printf(result ? "OK\n" : "NG\n"); \
    return result ? 0 : 1; }

#define NLIB_THREAD_EXIT_CPP_THROW_NLIB_EXCEPTION
#ifdef NLIB_EXCEPTION_ENABLED
#undef nlib_thread_cleanup_push
#undef nlib_thread_cleanup_pop
#define nlib_thread_cleanup_push(fn, arg) pthread_cleanup_push(fn, arg); try {
#define nlib_thread_cleanup_pop(exec) } catch(...) { { pthread_cleanup_pop(1) throw; } \
        pthread_cleanup_pop(exec)
#endif

#endif  // INCLUDE_NN_NLIB_CONFIG_OSX_H_
