Param([string]$CMake = "cmake.exe")

Push-Location .
$scriptDir = Split-Path -Parent $MyInvocation.MyCommand.Path
Set-Location $scriptDir

Set-Item Env:Path ((($Env:Path -split ';') -match '^(?!.*cygwin)') -join ';')

Push-Location .
try {
    New-Item cafe\Release -ItemType Directory
    Set-Location cafe\Release
    & $CMake -G Ninja -D CMAKE_TOOLCHAIN_FILE=..\..\..\cmake\toolchain-cafe-ninja.cmake -D CMAKE_BUILD_TYPE=Release ..\..\
    if (!$?) { throw }
} catch {
    Set-Location ..\..\
    Remove-Item cafe\Release -Recurse -Force
} finally {
    Pop-Location
}

Push-Location .
try {
    New-Item cafe\Debug -ItemType Directory
    Set-Location cafe\Debug
    & $CMake -G Ninja -D CMAKE_TOOLCHAIN_FILE=..\..\..\cmake\toolchain-cafe-ninja.cmake -D CMAKE_BUILD_TYPE=Debug ..\..\
    if (!$?) { throw }
} catch {
    Set-Location ..\..\
    Remove-Item cafe\Debug -Recurse -Force
} finally {
    Pop-Location
}

Pop-Location
